/*  formdata.C
 *  part of webobase
 *  Copyright (C) 1999 - 2002 Stefan Heimers (stefan@heimers.ch)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 
 *  59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/



#include <stdlib.h>

#ifdef FCGI
#include <fcgi_stdio.h>
#include <fcgio.h>
#else
#include <stdio.h>
#endif




#include <sys/types.h> 
#include <sys/stat.h> 
#include <unistd.h> 
#include <string.h>

#include "libshformdata.h"
#include "goodies.h"


#ifdef FCGI
//#include "fcgio.h"
#define cout fcout
#define cin fcin
#define cerr fcerr

extern fcgi_ostream cout;
extern fcgi_ostream cerr;
extern fcgi_istream cin;
#endif




char *form2sql(char *form)
{
  char *sqldata;
  size_t outsize,i,j,textlength;

  if (!form) return ""; //if an empty string is received

  textlength = strlen(form);
  outsize = textlength+1;
 


  sqldata = (char *) malloc(outsize+10);
  
  j=0;
  for (i=0;i<textlength;i++)
	{
	  if( *(form+i) == '
' )
		{
		  strcpy(sqldata+j,"");
		  j+=0;
		  i+=0;
		}
	  else if( !strncmp(form+i,"%E4",3) )
		{
		  strcpy(sqldata+j,"");
		  j+=1;
		  i+=2;
		}
	  else if( !strncmp(form+i,"%F6",3) )
		{
		  strcpy(sqldata+j,"");
		  j+=1;
		  i+=2;
		}
	  else if( !strncmp(form+i,"%3B",3) )
		{
		  strcpy(sqldata+j,";");
		  j+=1;
		  i+=2;
		}
	 
	  else if( !strncmp(form+i,"%FC",3) )
		{
		  strcpy(sqldata+j,"");
		  j+=1;
		  i+=2;
		}
	  else if ( !strncmp(form+i,"%40",3) )
		{
		  strcpy(sqldata+j,"@");
		  j+=1;
		  i+=2;
		}
	  else if ( !strncmp(form+i,"%26",3) )
		{
		  strcpy(sqldata+j,"&");
		  j+=1;
		  i+=2;
		}
	  else if ( !strncmp(form+i,"%2F",3) )
		{
		  strcpy(sqldata+j,"/");
		  j+=1;
		  i+=2;
		}
	  else if ( !strncmp(form+i,"%28",3) )
		{
		  strcpy(sqldata+j,"(");
		  j+=1;
		  i+=2;
		}
	  else if ( !strncmp(form+i,"%29",3) )
		{
		  strcpy(sqldata+j,")");
		  j+=1;
		  i+=2;
		}
	  else if ( !strncmp(form+i,"%3A",3) )
		{
		  strcpy(sqldata+j,":");
		  j+=1;
		  i+=2;
		}
	  else if ( !strncmp(form+i,"%3D",3) )
		{
		  strcpy(sqldata+j,"=");
		  j+=1;
		  i+=2;
		}
	  else if ( !strncmp(form+i,"%3C",3) )
		{
		  strcpy(sqldata+j,"&lt;");
		  j+=4;
		  i+=2;
		}

	  else if ( !strncmp(form+i,"%3E",3) )
		{
		  strcpy(sqldata+j,">");
		  j+=1;
		  i+=2;
		}

	  else if ( !strncmp(form+i,"%5C",3) )
		{
		  strcpy(sqldata+j,"\\");
		  j+=1;
		  i+=2;
		}


	  else if ( !strncmp(form+i,"%5E",3) )
		{
		  strcpy(sqldata+j,"^");
		  j+=1;
		  i+=2;
		}


	  else if ( !strncmp(form+i,"%7B",3) )
		{
		  strcpy(sqldata+j,"{");
		  j+=1;
		  i+=2;
		}
	  else if ( !strncmp(form+i,"%7D",3) )
		{
		  strcpy(sqldata+j,"}");
		  j+=1;
		  i+=2;
		}
	  else if ( !strncmp(form+i,"%7E",3) )
		{
		  strcpy(sqldata+j,"~");
		  j+=1;
		  i+=2;
		}
	  else if ( !strncmp(form+i,"%21",3) )
		{
		  strcpy(sqldata+j,"!");
		  j+=1;
		  i+=2;
		}
	  else if (!strncmp(form+i,"%27",3) )
		{
		  strcpy(sqldata+j,"\\'");
		  j+=2;
		  i+=2;
		}
	  else if (!strncmp(form+i,"%2B",3) )
		{
		  strcpy(sqldata+j,"+"); 
		  j+=1;
		  i+=2;
		}
	  else if (!strncmp(form+i,"%2C",3) )
		{
		  strcpy(sqldata+j,","); 
		  j+=1;
		  i+=2;
		}

	  else if (!strncmp(form+i,"%25",3) )
		{
		  strcpy(sqldata+j,"\\%"); 
		  j+=2;
		  i+=2;
		}
	  else if (!strncmp(form+i,"%E7",3) )
		{
		  strcpy(sqldata+j,""); 
		  j+=1;
		  i+=2;
		}
	  else if (!strncmp(form+i,"%22",3) )
		{
		  strcpy(sqldata+j,"\"");
		  j+=1;
		  i+=2;
		}
	  else if (!strncmp(form+i,"%09",3) )
		{
		  strcpy(sqldata+j,"\t");
		  j+=1;
		  i+=2;
		}
	  else if (!strncmp(form+i,"%0D",3) )
		{
		  strcpy(sqldata+j,"\n");
		  j+=1;
		  i+=2;
		}
	  else if (!strncmp(form+i,"%0A",3) )
		{
		  strcpy(sqldata+j,"\r");
		  j+=1;
		  i+=2;
		}
	  else if (!strncmp(form+i,"%24",3) )
		{
		  strcpy(sqldata+j,"$");
		  j+=1;
		  i+=2;
		}
	  else if (!strncmp(form+i,"%A3",3) )
		{
		  strcpy(sqldata+j,"");
		  j+=1;
		  i+=2;
		}
	  else if (!strncmp(form+i,"%3F",3) )
		{
		  strcpy(sqldata+j,"?");
		  j+=1;
		  i+=2;
		}

	  else if (!strncmp(form+i,"+",1) )
		{
		  strcpy(sqldata+j," ");
		  j+=1;
		
		}
	  else if (!strncmp(form+i,"%E9",3) )
		{
		  strcpy(sqldata+j,"");
		  j+=1;
		  i+=2;
		}
	  else if (!strncmp(form+i,"%E8",3) )
		{
		  strcpy(sqldata+j,"");
		  j+=1;
		  i+=2;
		}
	  else if (!strncmp(form+i,"%E0",3) )
		{
		  strcpy(sqldata+j,"");
		  j+=1;
		  i+=2;
		}
	  else if (!strncmp(form+i,"%F1",3) )
		{
		  strcpy(sqldata+j,"");
		  j+=1;
		  i+=2;
		}
	  else
		{
		  sqldata[j]=form[i];
		  j++;
		}
	}
  
  //sqldata[outsize-1]='\0';
  sqldata[j]='\0';
  return sqldata;
}


size_t charfind(char *buffer, char key, size_t pos)
{
  size_t i=0;
	while (buffer[i] != '\0')
	  {
		if (buffer[i] == key)
		  return i;
		else
		  i++;
	  }
	return i;
}


char *get_boundary()
{
  char bound[]="boundary=";
  char *content_type = getenv("CONTENT_TYPE");

  return strstr(content_type,bound)+9;
  
}


string get_line(char *buffer)
{
  char *end;

  string back;
  if (buffer[0]!='\0')
	{
	  end = strstr(buffer, "\n");
	  *end = '\0';
	  back = (string) buffer;
	  *end = '\n';
	}
  else
	back = "";
  return back;
}


// get the name of a multipart element
char *get_multiname(string line)
{
  size_t start,stop;
  char *buffer;
  if (line != "")
	{
  start = line.find("name=\"",0)+6;
  stop  = line.find("\"",start);

  cerr <<  "start, stop: " << start << "," << stop << endl;

  buffer = (char *) malloc(line.substr(start,stop-start).length());
  strncpy( buffer, line.substr(start,stop-start).c_str(),line.substr(start,stop-start).length()+1);
  buffer[stop-start]='\0';
	}
  else
	{
	  buffer = "";
	}
  return buffer;
}


// get the filename of a multipart element
char *get_multifilename(string line)
{
  size_t start,stop;
  char *buffer;

  if (line != "")
	{
	  start = line.find("filename=\"",0)+10;
	  stop  = line.find("\"",start);
	  
	  if ( start-10 != string::npos)
		{
		  buffer = (char *) malloc(line.substr(start,stop-start).length());	  
		  strncpy(buffer, line.substr(start,stop-start).c_str(),line.substr(start,stop-start).length()+1);
		  buffer[stop-start]='\0';
		  return buffer; (char *) line.substr(start,stop-start).c_str();
		}
	}
  return "";
}



void   formdata::insert_element(int type, string name, string filename, char *data,size_t size)
{
   size_t name_size;

  if (name_size = name.length())
	{
	  if (elements) // not first element
		{
		  elements->next = new struct form_elem_struct;
		  elements = elements->next;
		}
	  else // first element
		{
		  elements = new struct form_elem_struct;
		  elements_anchor = elements;
		}
	  if (size > 1)
		if (data[size-2] == '
')
		  {
			//data[size-2] = '\0';
			size = size - 2;
		  }
	  elements->name  = name;
	  elements->data  = data;
	  elements->filename = filename;
	  elements->datasize  = size;
	  elements->next  = NULL;
	}
}




// parse formdata and write each element to a searchable structure
formdata::formdata()
{
  char *buffer;
  size_t formsize;
  char *namebuffer,*valuebuffer;

  size_t start,stop,advance;



  elements = NULL;
  elements_anchor = 0;


  scriptname = getenv("SCRIPT_NAME");

#ifdef DEBUG
    fprintf(stderr,"debug: bevore REQUEST_METHOD, CONTENT_TYPE: %s,%s", getenv("REQUEST_METHOD"),securegetenv("CONTENT_TYPE"));
#endif


  //cerr << "bla error" << getenv("REQUEST_METHOD") << ", " << securegetenv("CONTENT_TYPE") << endl; 

  if (getenv("REQUEST_METHOD"))
	if ( !strncmp(getenv("REQUEST_METHOD"),"GET",3) + ( ((string)getenv("REQUEST_METHOD") == (string)"POST" )   * (securegetenv("CONTENT_TYPE") == (string)"application/x-www-form-urlencoded")) ) 
	  {
		// in methot GET formdata is transferred through an env. Variable
		//    fprintf(stderr,"debug: bevore CONTENT_TYPE");

	    content_type = URL_ENCODED;

	    if(securegetenv("CONTENT_TYPE") == (string)"application/x-www-form-urlencoded")
	      {
			formsize = atoi(getenv("CONTENT_LENGTH"));
			buffer=(char *) malloc(formsize+1);
			cin >> buffer;
			//fread(buffer,1,formsize,stdin); //daten vom Webbrowser einlesen
			
			cerr << "debug: POST read to buffer: " << buffer << " formsize: "<< formsize << endl;
	      }
	    else
	      {
			buffer = getenv("QUERY_STRING");
	      }
	    if (!buffer)
	      goto leave;
	    stop = 0;
		
		// only for debugging:
		//formstring = (string)buffer;

	    
	    while (start = charfind(buffer,'=',stop))
	      {
		//start = charfindfind(buffer,'=',stop);
		buffer[start] = '\0';
		namebuffer  = buffer;
		buffer = buffer + start + 1;
		start  = charfind(buffer,'&',stop);
		if ( buffer[start] == '\0')
		  advance =0;
		else
		  advance = 1;
		buffer[start] = '\0';
		valuebuffer = buffer;
		buffer = buffer + start + advance;
		insert_element(VAR,(string)namebuffer,"",valuebuffer,start+1);
		if (!advance)
		  goto leave;
	      }
	  leave:;
	  }
	else // method post
	  { 

	    content_type = FORMDATA;
#ifdef DEBUG
	    cerr << "debug: method post detected";
#endif
	    formsize = atoi(getenv("CONTENT_LENGTH"));
	    //fstat( fileno(stdin) ,&file_stat );
	    buffer=(char *) malloc(formsize+1);
	    fread(buffer,1,formsize,stdin); // read data submitted by the webbrowser


#ifdef DEBUG
		cerr << buffer;
#endif
    
	    char *bufferend=buffer+formsize;
	    
	    
	    char *boundary = get_boundary();
	    size_t boundarysize = strlen(boundary);
	    string line;
	    

#ifdef DEBUG
	    cerr  << "just read the buffer\nboundarysize:" << boundarysize << endl;
#endif
    
	  doitagain:


	    buffer = strstr(buffer, boundary)+boundarysize;

#ifdef DEBUG	    
	    cerr << "strstr 1: " << endl;
#endif


	    buffer = strstr(buffer, "\n")+1; // next line
#ifdef DEBUG	    
	    cerr << "strstr 2: buffer is"  << buffer << " \nlen: " << strlen(buffer) <<  endl;
#endif
	    
	    line = get_line(buffer);

#ifdef DEBUG	    
	    cerr << "line is: " << line << endl;
#endif
	    
	    namebuffer  = get_multiname(line);

#ifdef DEBUG	    
	    cerr << "found name: "  << namebuffer << endl;
#endif
	    
	    char *filenamebuffer = get_multifilename(line);

#ifdef DEBUG	    
	    cerr << "still have  name: "  << namebuffer << endl;	    
	    cerr << "found filename: "  << filenamebuffer << endl;
		cerr << "buffer is: *" << buffer << "*" << endl;
#endif
	    if (buffer[0] !='\0')
		  {
			buffer = strstr(buffer, "\n")+1; // next line
			if (buffer[0] !='\0')
			  buffer = strstr(buffer, "\n")+1; // next line
		  }
	    valuebuffer = buffer;


#ifdef DEBUG
			cerr  << "check if last element:" << endl;
#endif
	    
	    if (!strstr(buffer,boundary)) // last element
		  {
#ifdef DEBUG
			cerr  << "last 1:" << endl;
#endif
	      insert_element(BIN,  namebuffer, filenamebuffer, valuebuffer,bufferend-buffer);
#ifdef DEBUG
			cerr  << "last 2:" << endl;
#endif

		  }
	    else
	      {
#ifdef DEBUG
			cerr  << "not last 1:" << endl;
#endif

			insert_element(BIN,  namebuffer, filenamebuffer, valuebuffer,strstr(valuebuffer,boundary)-buffer-2);
			
#ifdef DEBUG
			cerr  << "doing it again (not last 2):" << endl;
#endif
	
			goto doitagain;
	      }
	    
	    //cout << formsize<< "\n boundary:>" << boundary << "<\n" << buffer << endl;
	  }


  // cookie management:
  // retrieve cookie if set, else create random text
  // and set it as a cookie named super_cookie

#ifdef DEBUG	    
  cerr << "cookies now"  << endl;
#endif


  cookie = "";
  if (getenv("HTTP_COOKIE"))
	{
	  cookie = (string)getenv("HTTP_COOKIE");
	  size_t offset = cookie.find("super_cookie=",0);
	  cookie = cookie.substr(offset+13,10);
	}
  if (cookie == "")
	cookie = rndstring(10);

#ifdef DEBUG
  cerr << "leaving formdata" << endl;  
#endif

}

formdata::~formdata()
{
}


string formdata::getval(string name)
{
  elements = elements_anchor;
  
  while (elements)
	{
	  if (elements->name == name)
		{
		  *((char *)(elements->data)+elements->datasize) = '\0';
		  if (content_type == FORMDATA)
		    return (string) elements->data;
		  else
		    return (string) form2sql((char *) elements->data);
		}
	  else
		elements = elements->next;
	}
  
  return "";
}

multistring *formdata::getmultival(string name)
{
  multistring *data,*data_anchor;
  elements = elements_anchor;

  data = NULL;
  data_anchor = NULL;
  
  while (elements)
	{
	  if (elements->name == name)
		{
		  *((char *)(elements->data)+elements->datasize) = '\0';
		  //return (string) form2sql((char *) elements->data);
		  if (!data)
			{
			  data = new multistring;
			  data->text = (string) form2sql((char *) elements->data);
			  data->next = NULL; 
			  data_anchor = data;
			}
		  else
			{
			  data->next = new multistring;
			  data = data->next;
			  data->text = (string) form2sql((char *) elements->data);
			  data->next=NULL;
			}
		}
	  elements = elements->next;
	}
  
  return data_anchor;
}


string formdata::getfilename(string name)
{
  elements = elements_anchor;
  
  while (elements)
	{
	  if (elements->name == name)
		{
		  *((char *)(elements->data)+elements->datasize) = '\0';
		  return  elements->filename;
		}
	  else
		elements = elements->next;
	}
  
  return "";
}



//  string formdata::writefile()
//  {
//    FILE *datafile;
//    string path;

//    cout << "started writefile <br>" << endl;

//    elements = elements_anchor;
  
//    while (elements)
//  	{
//  	  cout << "name is now:" << elements->name << "<br>";
//  	  if (elements->name == "datei")
//  		{
//  		  *((char *)(elements->data)+elements->datasize) = '\0';
//  		  //  return (string) (char *) elements->data;

		  
//  		  path = (string)DATAPATH +  elements->filename;
//  		  datafile = fopen(path.c_str(),"w");
//  		  elements->data+=2;
//  		  cout << "wrote " << fwrite(elements->data,1,elements->datasize-2,datafile) << "bytes to file" << path << endl ;

//  		  fclose(datafile);
//  		  return path;
//  		}
//  	  else
//  		elements = elements->next;
//  	}
//    //cout << "nothing apropriate<br>" << endl;
//    return "";
//  }




char formdata::exists(string name)
{
  
  elements = elements_anchor;
  while (elements)
	{
	  if (elements->name == name)
		return 1;
	  else
		elements = elements->next;
	}
  
  return 0;
  
}








